import { Point, Rect } from "./engine/datatypes.ts";

export function displace(
  bbox: Rect,
  dxy: Point,
  blocked: (where: Rect) => boolean,
  options?: { bounce?: number },
): { bbox: Rect; displacement: Point; dxy: Point } {
  let nSteps = 40;
  let bounce = options?.bounce ?? 0;

  let xy = bbox.top;
  for (let i = 0; i < nSteps; i++) {
    let trialXy = xy.offset(new Point(dxy.x / nSteps, 0));
    let trialBbox = new Rect(trialXy, bbox.size);

    if (blocked(trialBbox)) {
      dxy = new Point(bounce * -dxy.x, dxy.y);
    } else {
      xy = trialXy;
    }

    trialXy = xy.offset(new Point(0, dxy.y / nSteps));
    trialBbox = new Rect(trialXy, bbox.size);
    if (blocked(trialBbox)) {
      dxy = new Point(dxy.x, bounce * -dxy.y);
    } else {
      xy = trialXy;
    }
  }
  return {
    bbox: new Rect(xy, bbox.size),
    displacement: xy.offset(bbox.top.negate()),
    dxy,
  };
}
